import java.awt.*;
import java.awt.event.*;
import java.text.DecimalFormat;
import javax.swing.*;
import javax.swing.event.*;

// This whole class is an evil hack.

public class DoubleSlider extends JPanel implements ChangeListener {

	public final static int LINEAR = 0;
	public final static int LOGARITHMIC = 1;
	public final static int EXPONENTIAL = 2;

	static DecimalFormat fmt = new DecimalFormat("0.##E0");

	JLabel nameLabel;
	JSlider valueSlider;
	JLabel valueLabel;
	JLabel unitsLabel;

	int type;
	double m;
	double b;
	double value;


	public DoubleSlider(String name, double min, double max, String units) {
		this(name, min, max, units, LINEAR);
	}

	public DoubleSlider(String name, double min, double max, String units, int type) {

		double xmin;
		double xmax;
		if (type == LINEAR) {
			xmin = min;
			xmax = max;
		}
		else if (type == LOGARITHMIC) {
			xmin = Math.exp(min);
			xmax = Math.exp(max);
		}
		else {//(type == EXPONENTIAL)
			xmin = Math.log(min);
			xmax = Math.log(max);
		}
		m = (xmax - xmin) / 100;
		b = xmin;

		nameLabel = new JLabel(name);
		valueSlider = new JSlider();
		valueLabel = new JLabel(fmt.format(value));
		unitsLabel = new JLabel(units);
	
		valueSlider.addChangeListener(this);
		valueSlider.setValue(50);

		add(nameLabel);
		add(valueSlider);
		add(valueLabel);
		add(unitsLabel);

	}

	public double getValue() {
		return value;
	}

	public void stateChanged(ChangeEvent e) {
		if (valueSlider.getValueIsAdjusting()) {
			int i = valueSlider.getValue();
			double x = m*i + b;
			if (type == LINEAR) {
				value = x;
			}
			else if (type == LOGARITHMIC) {
				value = Math.log(x);
			}
			else if (type == EXPONENTIAL) {
				value = Math.exp(x);
			}
			valueLabel.setText(fmt.format(value));
		}
	}
}