package potential;

public class Gaussian extends Potential {

	private double a;
	private double mu;
	private double sigma;
	private double space_width;

	public Gaussian() {
		this(8e-19, 0.8, 0.1);
	}

	public Gaussian(double a, double mu, double sigma) {
		this.a = a;
		this.mu = mu;
		this.sigma = sigma;
	}

	public double value(double x) {
		double d = (x - mu) / sigma;
		return (a * Math.exp(-0.5 * d * d));
	}
}