package potential;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import javax.swing.JPanel;

abstract public class Potential {

	abstract public double value(double x);

	public void render(double[] v) {
		for (int i=0; i<v.length; i++) {
			v[i] = value((double)i/v.length);
		}
	}

	public void render(Graphics g, Dimension d, double scale) {
		for(int i=0; i<d.width; i++) {
			double x1 = (double)i/d.width;
			double x2 = (double)(i+1)/d.width;
			g.drawLine(
				i, (d.height/2) - (int)(value(x1)*scale),
				i+1, (d.height/2) - (int)(value(x2)*scale)
			);
		}
	}
}