package potential;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

public class VxEditor extends JPanel implements ItemListener {

	Potential Vx;
	JComboBox vxComboBox;
	JPanel display;

	static String[] functions = {
		"Constant",
		"Gaussian",
		"Half Parabolic",
		"Parabolic",
		"Step",
		"Custom"};

	public VxEditor() {

		Vx = new Constant(0);

		vxComboBox = new JComboBox(functions);
		vxComboBox.addItemListener(this);

		display = new JPanel() {
			public void paintComponent(Graphics g) {
				super.paintComponents(g);
				g.setColor(Color.black);
				Dimension d = getSize();
				g.fillRect(0, 0, d.width, d.height);
				g.setColor(Color.red);
				g.drawLine(0,d.height/2,d.width,d.height/2);
				double r = 3e18 / (2*2) * (d.height/2);
				g.setColor(Color.white);
				Vx.render(g, d, r);
			}
		};
		display.setPreferredSize(new Dimension(200,150));

		add(vxComboBox);
		add(display);
	}

	public Potential getPotential() {
		return Vx;
	}

	public void itemStateChanged(ItemEvent e) {
		if (e.getStateChange() == ItemEvent.SELECTED) {
			String name = (String)e.getItem();
			if (name.equals(functions[0])) {
				Vx = new Constant();
			}
			else if (name.equals(functions[1])) {
				Vx = new Gaussian();
			}
			else if (name.equals(functions[2])) {
				Vx = new HalfParabolic();
			}
			else if (name.equals(functions[3])) {
				Vx = new Parabolic();
			}
			else if (name.equals(functions[4])) {
				Vx = new Step();
			}
			else if (name.equals(functions[5])) {
			}
			else {
				Vx = new Constant(0);
			}
		}
		display.repaint();
		
	}
	
}